//without risk
//trust = 0; die out
//output medium ties
//this is before decay for the next turning
//
package version2012;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.List;


public class Sociaty implements Runnable
{
	static DecimalFormatSymbols decimalFormatSymbols = new DecimalFormatSymbols();
	static DecimalFormat decimalFormat = new DecimalFormat("0.00", decimalFormatSymbols);
	
	
	private List<Ego> egoes;		
	public int population;
	
	public static final int iterations = 5000;
	public static final int generations = 50;	
	
	public static boolean crossoverEM = false;
	public static boolean crossoverST = false;
	public static boolean crossoverDe = false;		

	public static final boolean DEFENSE = true;
	public static final boolean symmetrical = false;
	public static final boolean rewardDefection = true;	
	
	private static final double mutationRate = 0.01d; 

	public static double[] eatMeetGenesIni = {0.125, 0.2, 0.25, 0.5};
	public static double[] DefectGenesIni = {0.01, 0.025, 0.05, 0.075};
	
	public static double maxEMR = 0.5d;
	public static double minEMR = 0.125d;

	public static double maxD = 0.075d;
	public static double minD = 0.01d;
	
	public static int mutationSlots = 1000;
	public static double gradEMR = (maxEMR - minEMR)/mutationSlots;
	public static double gradD = (maxD - minD)/mutationSlots;
	
	
	double g1_thr = 0.8;
	double g2_thr = 0.2;
	int[] g1; //number of a > g1_thr
	int[] g2; //number of a < g2_thr
	int[] g3; //middle
	
	public static final double killRate = 0.2d;
	public static double strongTiesThr = 66;
	public static double mediumTiesThr = 33;
	
	public double rescouseWeight;
	public double wellBeingWeight;	
	public double riskWeight;
	public double allianceWeight;	
	public double stressWeight;

	String strongpercentage;
	
	public Sociaty(List<Ego> egoes, double rescouseWeight, double wellBeingWeight, double allianceWeight, double riskWeight, double stressWeight,
			double strong_percnetage) 
	{
		this.egoes = egoes;	
		population = egoes.size();
		setEatRatio();
		setMinDefectRate();
		g1 = new int[generations + 1];
		g2 = new int[generations + 1];
		g3 = new int[generations + 1];
		this.rescouseWeight = rescouseWeight;
		this.wellBeingWeight = wellBeingWeight;
		this.riskWeight = riskWeight;
		this.allianceWeight = allianceWeight;
		this.stressWeight = stressWeight;
		if(strong_percnetage > 0)
		{
			strongpercentage = decimalFormat.format(strong_percnetage) + "-";
		}
		else
		{
			strongpercentage = "";
		}
	}

	
	public void setEatRatio()
	{
		for(int i = 0; i < population; i++)
		{
			int index = (int)Math.floor(Math.random() * eatMeetGenesIni.length);
			egoes.get(i).setEatRatio(eatMeetGenesIni[index]);
		}
	}
	
	public void setMinDefectRate()
	{
		for(int i = 0; i < population; i++)
		{
			int index = (int)Math.floor(Math.random() * DefectGenesIni.length);
			egoes.get(i).setMinDefectRate(DefectGenesIni[index]);
		} 
	}

	private void remove(Ego ego)
	{
		int removedID = ego.getID();
		for(int i = 0; i < egoes.size(); i++)
		{
			egoes.get(i).removeLog(removedID);
		}
		egoes.remove(ego);
	}
	
	public void reset()
	{
		//reset and mutate
		for(int i = 0; i < population; i++)
		{
			egoes.get(i).reset();
			if(Math.random() < mutationRate)
			{
				egoes.get(i).mutate();
				egoes.get(i).mutate_on_a();
			}
		}
	}	

	public void run() 
	{

try {
		String fileName = String.valueOf(rescouseWeight)+ "-" +
			String.valueOf(wellBeingWeight) + "-" +
			String.valueOf(allianceWeight) + "-" +
			String.valueOf(riskWeight) + "-" +
			String.valueOf(stressWeight) + "-" +
			strongpercentage +
			String.valueOf(population + ".txt");

		BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
		int total = iterations * generations;
		double[] trustStrong = new double[total];
		double[] trustWeak = new double[total];
		double[] trustMedium = new double[total];
		double[] strongTies = new double[total];
		double[] weakTies = new double[total];
		double[] mediumTies = new double[total];
		double[] aver_total_trust = new double[total];
		double[] total_num_ties = new double[total];
		
		double[] averageEatMeetRatio = new double[generations + 1];
		averageEatMeetRatio[0] = 0.26875;
		double[] averageDefectRatio = new double[generations + 1];
		averageDefectRatio[0] = 0.0475;
		
		double[][] trustFreq = new double[generations][100];

		
		for(int i = 0; i < generations; i++)
		{
			for(int j = 0; j < 100; j++)
			{
				trustFreq[i][j] = 0;
			}
		}
		
		Ego selectedEgo = null;
		int newIndex = population;
		
		String s = "index," +
		"average trust for strong ties," +
		"average trust for medium ties," +
		"average trust for weak ties," +
		"average strong ties, " +
		"average medium ties, " +
		"average weak ties," +
		"average total ties," +
		"average trust";
		out.append(s + "\n");

        double[] a = new double[generations + 1];
		for(int i = 0; i < egoes.size(); i++)
		{
			if(egoes.get(i).a > g1_thr)
			{
				g1[0]++;
			}
			else if(egoes.get(i).a < g2_thr)
			{
				g2[0]++;
			}
			else
			{
				g3[0]++;
			}
			a[0] += egoes.get(i).a;
		}
		a[0] /= population;
		
		
		for(int k = 0; k < generations; k++)
		{
			reset();
			for(int i = 0; i < iterations; i++)
			{
				for(int j = 0; j < population; j++)
				{
					selectedEgo = egoes.get(j);
					selectedEgo.tiesDecay();
				}	
				
				int ik = k * iterations + i;
				trustStrong[ik] = 0;
				trustWeak[ik] = 0;
				trustMedium[ik] = 0;
				strongTies[ik] = 0;
				weakTies[ik] = 0;
				mediumTies[ik] = 0;
				aver_total_trust[ik] = 0;
				total_num_ties[ik] = 0;
				
				for(int j = 0; j < population; j++)
				{
					selectedEgo = egoes.get(j);
					selectedEgo.runATurn(egoes, k, i, population);

					trustStrong[ik] += selectedEgo.getTotalStrongTrust();
					trustWeak[ik] += selectedEgo.getTotalWeakTrust();
					trustMedium[ik] += selectedEgo.getTotalMediumTrust();
					strongTies[ik] += selectedEgo.getStrongTies();
					weakTies[ik] += selectedEgo.getWeakTies();
					mediumTies[ik] += selectedEgo.getMediumTies();
					aver_total_trust[ik] += selectedEgo.get_total_trust();
					total_num_ties[ik] += selectedEgo.getTotalNumberTies();
				}			
				
				trustStrong[ik] /= strongTies[ik];
				trustWeak[ik] /= weakTies[ik];
				trustMedium[ik] /= mediumTies[ik];
				strongTies[ik] /= population;
				weakTies[ik] /= population;
				mediumTies[ik] /= population;
				aver_total_trust[ik] /= total_num_ties[ik];
				

//System.out.print(ik + ",");
//System.out.print(trustStrong[ik] + ",");
//System.out.print(trustMedium[ik] + ",");
//System.out.print(trustWeak[ik] + ",");
//System.out.print(strongTies[ik] + ",");
//System.out.print(mediumTies[ik] + ",");
//System.out.print(weakTies[ik] + ",");
//System.out.println((strongTies[ik]+mediumTies[ik]+weakTies[ik]));		
			}
			
			int ik = (k + 1) * iterations - 1;
			System.out.print((k + 1) + ",");
			out.append((k + 1) + ",");
			out.append(trustStrong[ik] + ",");
			out.append(trustMedium[ik] + ",");
			out.append(trustWeak[ik] + ",");
			out.append(strongTies[ik] + ",");
			out.append(mediumTies[ik] + ",");
			out.append(weakTies[ik] + ",");
			out.append((strongTies[ik]+mediumTies[ik]+weakTies[ik]) + ",");
			out.append(aver_total_trust[ik] + "\n");
			
			if(k < generations - 1)
			{
				//selection
				//rank resource
				Ego[] egosResource = new Ego[population];
				for(int i = 0; i < population; i++)
				{
					egosResource[i] = egoes.get(i);
					
				}
				QuickSort.quickSort(egosResource, 0, population - 1, QuickSort.resource, this);
				double score = 1;
				for(int i = 0; i < population; i++)
				{
					egosResource[i].scoreResource = score;
					score++;
				}	
				//rank wellbeing
				Ego[] egosWellBeing = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosWellBeing[i] = egoes.get(i);					
				}
				QuickSort.quickSort(egosWellBeing, 0, population - 1, QuickSort.wellbeing, this);
				score = 1;
				for(int i = 0; i < population; i++)
				{
					egosWellBeing[i].scorewellbeing = score;
					score++;
				}							
				//rank alliance
				Ego[] egosAlliance = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosAlliance[i] = egoes.get(i);					
				}
				QuickSort.quickSort(egosAlliance, 0, population - 1, QuickSort.alliance, this);
				score = 1;
				for(int i = 0; i < population; i++)
				{
					egosAlliance[i].scoreAlliance = score;
					score++;
				}		
				//rank risk
				Ego[] egosRisk = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosRisk[i] = egoes.get(i);
				}
				QuickSort.quickSort(egosRisk, 0, population - 1, QuickSort.risk, this);
				score = population;
				for(int i = 0; i < population; i++)
				{
					egosRisk[i].scoreRisk = score;
					score--;
				}	
				//rank stress
				Ego[] egosStrss = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosStrss[i] = egoes.get(i);
				}
				QuickSort.quickSort(egosStrss, 0, population - 1, QuickSort.stress, this);
				score = population;
				for(int i = 0; i < population; i++)
				{
					egosStrss[i].scoreStress = score;
					score--;
				}	
				//rank score
				Ego[] egosScore = new Ego[population];			
				for(int i = 0; i < population; i++)
				{
					egosScore[i] = egoes.get(i);
				}
				QuickSort.quickSort(egosScore, 0, population - 1, QuickSort.overall, this);


				for(int i = 0; i < population * killRate; i++)
				{				
					remove(egosScore[i]);
				}		

				//breeding
				for(int i = 0; i < population * killRate; i++)
				{
//					Ego tmp = egosScore[population - i - 1];
					Ego ego = new Ego(newIndex, egosScore[population - i - 1]);
					egoes.add(ego);
					newIndex++;
				}
				
				for(int i = 0; i < egoes.size(); i++)
				{

					if(egoes.get(i).a > g1_thr)
					{
						g1[k + 1]++;
					}
					else if(egoes.get(i).a < g2_thr)
					{
						g2[k + 1]++;
					}
					else
					{
						g3[k + 1]++;
					}
					a[k + 1] += egoes.get(i).a;
					averageEatMeetRatio[k + 1] += egoes.get(i).getEatMeetRatio();
					averageDefectRatio[k + 1] += egoes.get(i).getDefectRate();
				}
				a[k + 1] /= population;
				averageEatMeetRatio[k + 1] /= population;
				averageDefectRatio[k + 1] /= population;
			}

		}
		out.append("\n\n");
		s = "generation,strong preferred,weak preferred, stage preferred, average a";
		out.append(s + "\n");
		for(int i = 0; i < generations; i ++)
		{
			out.append((i + 1) + ",");
			out.append(String.valueOf(g1[i]) + ",");
			out.append(String.valueOf(g2[i]) + ",");
			out.append(String.valueOf(g3[i]) + ",");
			out.append(String.valueOf(a[i]) + "\n");
		}		
		
		out.append("\n\n");
		s = "generation,average eat/meet ratio,min defect rate";
		out.append(s + "\n");
		for(int i = 0; i < generations; i ++)
		{
			out.append((i + 1) + ",");
			out.append(String.valueOf(averageEatMeetRatio[i]) + ",");
			out.append(String.valueOf(averageDefectRatio[i]) + "\n");
		}			
		out.close();
		drawTrustDrig(20);		

} catch (Exception e) {
	e.printStackTrace();
}
	}			 
	 
	 public void drawTrustDrig(int num_girds) throws IOException
	 {

			String fileName = String.valueOf(rescouseWeight)+ "-" +
				String.valueOf(wellBeingWeight) + "-" +
				String.valueOf(allianceWeight) + "-" +
				String.valueOf(riskWeight) + "-" +
				String.valueOf(stressWeight) + "-" +
				strongpercentage +
				String.valueOf(population + "-trust.txt");
			BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
	        double[] trust = new double[num_girds]; 
	        for(int i = 0; i < population; i++)
	        {
	        	double[] localTrust = egoes.get(i).getTrustDistribution(num_girds);
	        	for(int j = 0; j < num_girds; j++)
	        	{
	        		trust[j] += localTrust[j];
	        	}	        			
	        }

        	for(int j = 0; j < num_girds; j++)
        	{
        		trust[j] /= population;
        	}	
        	
        	for(int j = num_girds - 2; j >= 0; j--)
        	{
        		trust[j] = trust[j + 1] + trust[j];
        	}	
        	
	        int gap = 100 / num_girds;
        	out.append("frequency, trust\n");
	        for(int i = 0; i < num_girds; i++)
	        {
	        	out.append(trust[i] + "," + String.valueOf((int)((i + 1) * gap)) + "\n");
	        }
	        out.close();     
	 }
}
